 @echo off
setlocal enabledelayedexpansion enableextensions
rem AutoCal.bat

goto :CHECKHELP

	Flowchart:

	New changes 09/21/2011:
		
	


	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
:CHECKHELP
	rem CONSTANTS
	set bat_vers=0.976
	set bat_calnstars=80
	set bat_caloc=2.50


	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_logfile=!bat_startlocation!\AutoCams.bat.log
	set bat_caldir=!bat_startlocation!\Cal
	
	call :RESET

	set bat_precapturedfilesdir=%~1
	set bat_capturedfilesdir=%~1
	set bat_archivedfilesdir=%~2
	set bat_camera=%~3
	
	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
	)
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0
	rem call :READCONFIG
		call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
		call :GETCONFIRMEDCOUNT

	call :PARSEARGS %*

	if not exist "!bat_mainspec!\!bat_getdirname!" (
		!bat_echolog! '     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		!bat_echolog! exit /b 1
		exit /b 1
	) else (
		!bat_echolog! '     bat_mainspec=!bat_mainspec!
	)
	
	call :AUTOCAMS
	echo.
	echo Done with %0 %*
	echo.
goto :DONE

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %* [%1, %~dp1, %~nx1]
	set bat_getdirname=%~nx2
	set bat_arg1=%~2

	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"

	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			!bat_echolog! '     Format: x:\CAMS\ArchivedFiles\date/time
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			!bat_echolog! '     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			!bat_echolog! '     %~1|find /i /c "ArchivedFiles\"
			!bat_echolog! '     !errorlevel!
			if !errorlevel! equ 0 (
				!bat_echolog! '     Format: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				!bat_echolog! '     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
!bat_echolog! return-:PARSEARGS [!bat_getdirname!, !bat_mainspec!, !bat_mainfilter!]
%return%





	rem R. Reset ******************************************
:RESET
	set bat_captureddate=
	set bat_capturedfilesdir=
	set bat_capturedcount=
	set bat_archivedfilesdir=
	set bat_archivedcount=
	set bat_archdirname=
	set bat_archivedate=
	set bat_archivedcount=
	set bat_archivedmeteorcount=
	set bat_confirmedfilesdir=
	set bat_confirmedmeteorcount=
	set bat_latestcal=
	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=
	set bat_zipfile=
	set bat_zip=
	set bat_recent_error_msg=
	
	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_calupdate=false
	set bat_hasrun_cal=false
	set bat_hasrun_confirm=false
	set bat_hasrun_submission=false
	set bat_hasrun_zip=false

%bat_return%



	rem a. AutoCams  ***************************
:AUTO
!bat_echolog! call :AUTO %*
	!bat_echolog! '    start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
					   start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
!bat_echolog! return-:AUTO [!bat_capturedfilesdir!]
%bat_return%


:AUTOCAMS
echo call :AUTOCAMS %*
	rem This routine performs the following steps:
	
	
	set bat_recent_error_msg=

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		echo.
		!bat_echolog! '    ERROR - "!bat_archivedfilesdir!" is missing dir name
		goto :AUTOCAMS_END
	)


:AZ_FIXDETECTPATHS
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!"
	if !errorlevel! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file
		goto :AUTOCAMS_END
	)
:AZ_CALAUTO
	rem   7b. FTP_MeteorCal_AutoUpdate
	call :CALUPDATEAUTO
	if "!bat_returncode!" neq "0" (
		set bat_recent_error_msg=ERROR - Auto Calibration failed
		goto :AUTOCAMS_END
	)

:AZ_APPLYAUTO
	rem   9.  FTP_ApplyCal2detectinfo
	call :APPLYAUTO
	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=ERROR - ApplyAuto failed
		goto :AUTOCAMS_END
	)

:AZ_FIXDETECTPATHSCONF
	call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!
	if !errorlevel! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file
	)

:AZ_APPLYCONFIRMED
	rem   9.  FTP_ApplyCal2detectinfo
	call :APPLYCONFIRMED
	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=ERROR - Apply Confirmed failed
	)

goto :AUTOCAMS_END

:AUTOCAMS_END
echo return-:AUTOCAMS %*
	echo .........Waiting 60 seconds
	for /L %a in (1,1,60) do (start /w wait 1)
%bat_return%




:GETCAMERAFROMCAPTURED
!bat_echolog! call :GETCAMERAFROMCAPTURED %*
	set /a bat_capturedcount=0
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)

!bat_echolog! return-:GETCAMERAFROMCAPTURED [bat_camera=!bat_camera, bat_capturedcount=!bat_capturedcount!]
%bat_return%




:	rem 5. SkippedFrames ******************************************
:SKIPPEDFRAMES
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\skippedFrames.bat "!bat_capturedfilesdir!" /v
	     call !bat_exedir!\SkippedFrames.bat "!bat_capturedfilesdir!" /v

	cd /d !bat_exedir!
	
	pause
%bat_return%



:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%



	rem 7b. Cal Auto Update ********************************************
:CALUPDATEAUTO
!bat_echolog! call :CALUPDATEAUTO %* [bat_archivedmeteorcount=!bat_archivedmeteorcount!]
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		!bat_echolog! '    You probably don't want to do this - you have already run Submission: 
		if not defined bat_autonomous (
			set /p bat_choice=[Enter] to quit, 
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=[!bat_returncode!]
			goto :CALUPDATEAUTO_END
		)
	)
	
	rem should be something like:
	rem   call :autocalupdate.bat 100 1.00 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem and then check the autocal log for success/failure


	if /i "!bat_archivedmeteorcount!" equ "0" (
		!bat_echolog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
		goto :CALUPDATEAUTO_END
	) else (
		!bat_echolog! '    call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
					       call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		set bat_retval=executed
	)
	
	!bat_echolog!
	rem Validate the AutoCalUpdate.log file
	for /f "usebackq tokens=1-12" %%a in (`find /i "camera" "!bat_capturedfilesdir!\AutoCalUpdate.log"^|find /i "camera !bat_camera!"`) do (
		echo %%a,%%b,%%c,%%e,%%f,%%g,%%h,%%i
		set bat_autocal_camera=%%b
		set bat_autocal_success=%%c
		set bat_autocal_nstars=%%d
		set bat_autocal_oc=%%e
		set bat_autocal_fffile=%%f
		set bat_autocal_calfile=%%g
		
		if !bat_autocal_oc! GTR !bat_caloc! (
			set bat_autocal_success=1
			!bat_echolog!
			!bat_echolog! '    ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
			!bat_echolog!
			!bat_echolog! '    Camera:	!bat_autocal_camera!
			!bat_echolog! '    Success:	FAILED
			!bat_echolog! '    nStars:	!bat_autocal_nstars!
			!bat_echolog! '    O-C:	!bat_autocal_oc!
			!bat_echolog! '    FF file:	!bat_autocal_fffile!
			!bat_echolog! '    calfile:	!bat_autocal_calfile!
			!bat_echolog!

			rem Delete the cal file if the O-C value is too high, even though
			rem the .exe program thinks it's ok. 
			if exist "!bat_caldir!\!bat_autocal_calfile!" (
				del "!bat_caldir!\!bat_autocal_calfile!"
			)
		)
	)
	
	if /i "!bat_autocal_success!" neq "0" (
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=[!bat_returncode!]
	) else (
		!bat_echolog!
		!bat_echolog! '    Camera:	!bat_autocal_camera!
		!bat_echolog! '    Success:	SUCCESS
		!bat_echolog! '    nStars:	!bat_autocal_nstars!
		!bat_echolog! '    O-C:		!bat_autocal_oc!
		!bat_echolog! '    FF file:	!bat_autocal_fffile!
		!bat_echolog! '    calfile:	!bat_autocal_calfile!
		!bat_echolog!
	)
	

:CALUPDATEAUTO_END
!bat_echolog! return-:CALUPDATEAUTO [!bat_retval!, !bat_returncode!]
%bat_return%





:CALC_CAL_VALUES
	set bat_calra=%~1
	set bat_caldec=%~2
	set bat_choice=%~3
	set bat_time=%~4

	rem calculate the entered time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~0,2! bat_hh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~2,2!00 bat_mm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~4,2!00 bat_ss

	echo set /a "bat_hour=((!bat_ss! / 60) + !bat_mm!) / 60) + !bat_hh!00"
		 set /a "bat_mmdecimal=((!bat_ss! / 60) + !bat_mm!) / 60"
	set /a bat_hour=!bat_hh!00 + !bat_mmdecimal!
	set bat_hourdisplay=!bat_hh!.!bat_mmdecimal!


	rem calculate the old cal file time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~0,2! bat_timehh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~3,2!00 bat_timemm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~6,2!00 bat_timess

	set /a "bat_timemmdecimal=((!bat_timess! / 60) + !bat_timemm!) / 60"
	set /a bat_timetotal=!bat_timehh!00+!bat_timemmdecimal!
	set bat_timemmdecimal=!bat_timemmdecimal!0000
	set bat_timemmdecimal=!bat_timemmdecimal:~0,4!
	set bat_timetotal=!bat_timehh!!bat_timemmdecimal!

	set /a bat_timediff=!bat_hour!00 - !bat_timetotal!
	set /a bat_diffdegrees=!bat_timediff! * 15


	rem Caluclate the new RA value based on the difference in hours
	set bat_temp2=
	call "!bat_exedir!\STRIPZEROS.bat" !bat_calra! bat_calra
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_calra!') do (
		set bat_radeg=%%a
		set bat_radegdecimal=%%b

		set bat_temp2=!bat_radegdecimal!0000
		set bat_temp2=!bat_temp2:~0,4!
		set bat_ratotal=!bat_radeg!!bat_temp2!

		set /a bat_ranew=!bat_ratotal! + !bat_diffdegrees!
		if !bat_ranew! GEQ 3600000 (
			set /a bat_ranew=3600000 - !bat_ranew!
		)
	)

	echo.
	echo     Data from current calibration file: !bat_detectcalfile!
	echo        time=!bat_time!, !bat_timetotal!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!
	echo        RA  =!bat_retval1!, !bat_ratotal!
	echo        DEC =!bat_retval2!
	echo.
	rem echo     bat_timediff=!bat_timediff!
	rem echo     bat_diffdegrees=!bat_diffdegrees!
	rem echo.
	echo     Data from the FF file based on the entered time segment: !bat_choice!
	echo        time=!bat_hour:~0,-2!.!bat_hour:~-2!
	echo        RA  =!bat_ranew!
	echo        DEC =!bat_caldec!
	echo.

		
:CALC_CAL_VALUES_END
rem echo return-:CALC_CAL_VALUES [in=%*] [!bat_timetotal!, !bat_hour!, !bat_ranew!, !bat_diffdegrees!]
%bat_return%


	rem 9. Apply cal to detectinfo *******************************
:APPLY
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :APPLY_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :APPLY_END
	)
	
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	cd /d !bat_exedir!

	set bat_latestcal=
	echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal (
			set bat_latestcal=%%a
			echo.
			echo   Reading the current FTPdetectinfo.txt file and scanning for the cal
			echo   file now in use...
			echo      "!bat_latestcal!"
		)
	)


:APPLY_END
	pause
%bat_return%



	rem 9. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_echolog! call :APPLYAUTO %*
	set bat_retval=failed
	set bat_latestcal=

	if "!bat_archivedmeteorcount!" equ "0" (
		!bat_errorlog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous
						    call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" autonomous>nul:
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR ApplyCal.bat failed
			goto :APPLYAUTO_END
		)

		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do ...
		for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
			if not defined bat_latestcal (
				set bat_latestcal=%%a
			)
		)
	)


	!bat_echolog! '    Cal file in "!bat_archivedfilesdir!\FTPdetectinfo.txt":
	!bat_echolog! '    "!bat_latestcal!"
	if defined bat_latestcal (
		set bat_retval=success
	)
	
:APPLYAUTO_END
!bat_echolog! return-:APPLYAUTO [!bat_retval!, "!bat_latestcal!"]
%bat_return%






:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!]
%bat_return%



	rem 12. Apply cal to ConfirmedFiles **************************
:APPLYCONFIRMED
	set bat_returncode=0
	set bat_retval=failed
	set bat_latestconfcal=

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		set bat_returncode=1
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - You need to Choose ArchivedFiles first:
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)
	
	set bat_archivedfilesdir
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_confirmedfilesdir
	
	if "!bat_confirmedmeteorcount!" equ "0" (
		set bat_returncode=1
		!bat_errorlog! '    NOTE - Confirmed Meteor Count is 0. Nothing to calibrate.
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
						    call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR ApplyCal.bat failed
			goto :APPLYAUTO_END
		)

		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"`^) do ...
		for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"`) do (
			if not defined bat_latestconfcal (
				set bat_latestconfcal=%%a
			)
		)
	)


	!bat_echolog! '    Cal file in "!bat_confirmedfilesdir!\FTPdetectinfo.txt":
	!bat_echolog! '    "!bat_latestconfcal!"
	if defined bat_latestconfcal (
		set bat_retval=success
	)

	
:APPLYCONFIRMED_END
	if not defined bat_autonomous (
		pause
	)
%bat_return%





:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%




:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval= 
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)

echo return-:SEARCHFORDIR: bat_retval=!bat_retval!, bat_retval2=!bat_retval2!, bat_retval3=!bat_retval3!
%bat_return%




	rem 18. Email notice ******************************************
:EMAILTEXT
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.

	echo     The CAMS files for Camera !bat_camera! for Capture Date of !bat_captureddate! 
	echo     have been processed.  
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	echo     Details for the submission follow...
	echo.
	echo     Scanning for zip files in ["!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"]...
	set bat_zipfile=
	if exist "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
			set bat_zipfile=!bat_targetlocation!\CAMS\Transmitted\%%~a
		)
		
		if defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS been uploaded 
			echo       to the FTP server.  The file name is:
			echo          "!bat_zipfile!"
		)
	) else (
		if not defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS NOT been  
			echo       uploaded.  The file name should have been:
			echo          "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"

			echo.
			if exist "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" (
				echo       Scanning for zip files in ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]...
				set bat_zipfile2=
				for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
					set bat_zipfile2="!bat_targetlocation!\CAMS\Submitted\%%~a"
				)
				if defined bat_zipfile2 (
					echo         The zip file was created here, but was not uploaded:
					echo            "!bat_zipfile2!"
				)
			)
		)
	)
	
	echo.
	echo.
	set bat_emailfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\arch*.txt" /b`) do (
		for /f "tokens=1-6 delims=.,=" %%i in ("!bat_emailfilesdir!\%%h") do (
			echo                     Archived    Confirmed
			echo     Meteor Count    %%j          %%l
		)
	)

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_submissionfilesdir!\!bat_camera!\Cal\%%h
	)

	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			set bat_temp=%%~h                              
			set bat_temp=!bat_temp:~0,27!
			echo  !bat_temp! =%%i
		)
	)



	
::GETCALFILENSTARS	
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	echo   Cal stars used             = !bat_calfilestars!

::SHOWSKIPPEDFRAMES
	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
						 call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
				)
			)
		)
	)
	pause
%bat_return%
goto :EOF


:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%



:CHECKBINFILESIZE
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
%bat_return%






	rem 6u. ValidateCal ********************************************
:VALIDATECAL
	set bat_temp=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	set bat_targetfilespec=!bat_caldir!\CAL???_*.txt

	if defined bat_captureddate (
		set bat_targetfilespec=!bat_caldir!\CAL!bat_camera!_!bat_temp!*.txt
	)

	if defined bat_latestcal (
		echo.
		echo   Current CAL file information is:
		echo   bat_camera=!bat_camera!
		echo   bat_latestcal=!bat_latestcal!
		set bat_targetfilespec=!bat_caldir!\!bat_latestcal!
		shift
		shift
	)

	echo call ValidateCal.bat /cal "!bat_targetfilespec!"
	     call ValidateCal.bat /cal "!bat_targetfilespec!"

	pause
%bat_return%





	rem 18u. Save Configuration ************************************
:SAVECONFIG
rem !bat_echolog! call :SAVECONFIG %*
rem !bat_echolog! return-:SAVECONFIG
%bat_return%
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
rem !bat_echolog! return-:SAVECONFIG
%bat_return%





:READCONFIG
rem !bat_echolog! call :READCONFIG %*
rem !bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		rem echo set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!
	
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
	call :GETCONFIRMEDCOUNT
rem !bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%



	rem u19. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
	)
%return%



:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	if !errorlevel! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file ""%~1\%2"
		goto :FIXDETECTPATHS_END
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS []
!bat_return!



:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "capturedfilesdir" "archivedfilesdir" camera [autonomous]
	echo.
	echo Performs the AutoCal like it does in AutoCams.bat
	echo.
	echo Where:
	echo   capturedfilesdir			is the full CapturedFiles dir path
	echo   archivedfilesdir         is the full ArchivedFiles dir path
	echo   camera                   is the camera number used during capture
	echo   autonomous               [optional] If included, it runs withou
	echo                            user prompts.
	echo.
	echo For autonomous mode, use the following command line options:
	echo.
	echo        %~nx0 ^<"capturedfilesdir"^> ^<"archivedfilesdir"^> ^<camera^> autonomous
	echo.
	echo Example:
	echo    %~nx0 "C:\CAMS\CapturedFiles\2011_12_25_01_33_46" "C:\CAMS\ArchivedFiles\2011_12_25_01_35_05" 299 autonomous
	echo.
exit /b 9



:DONE
	call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
