 @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	setlocal enableextensions enabledelayedexpansion
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
    set bat_return=goto :EOF
    
    set bat_exedir=%~dp0
    set bat_exedir=!bat_exedir:~0,-1!
    set bat_exedrive=!bat_exedir:~0,2!

	rem 0123456789a123
	rem Tue 10/18/2011
	rem 10/18/2011
	
	set bat_curdate=%date:~-10%
	if "%~1" neq "" (
		set bat_curdate=%~1
	)

	set bat_curdate=!bat_curdate:~-10!
	
	echo.%bat_curdate%|find /i "/">nul:
	if %errorlevel% equ 0 (
		rem echo for /f "delims=/ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=/ tokens=1-3" %%a in ("!bat_curdate!") do (
			rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	) else (
		rem echo for /f "delims=_ tokens=1-3" %%a in ^("!bat_curdate!"^) do ,,,
		for /f "delims=_ tokens=1-3" %%a in ("!bat_curdate!") do (
			rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	)

:SETUP2	
	set bat_date=!bat_cury:~-4!_!bat_curm:~-2!_!bat_curd:~-2!
	set bat_curdate=!bat_curm:~-2!/!bat_curd:~-2!/!bat_cury:~-4!
	rem set bat_datemin=!bat_year:~-4!!bat_mo:~-2!!bat_da:~-2!


	rem set bat_curm=!bat_curdate:~-2!
	rem set bat_curd=!bat_curdate:~-2!
	rem set bat_cury=!bat_cury:~-4!
	rem set bat_cury=!bat_cury:~-4!
	set /a bat_prevy=!bat_cury!-1
	
	set bat_sunsettable=%~dp0twilight.csv.txt
	
:DAYOFWEEK
	call :date2jdate bat_JD !bat_cury! !bat_curm! !bat_curd!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)

	rem echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!

	
	echo %~0 %*
	echo.
	echo Usage: %~0 mm/dd/yyyy   - Checking sunset table for !bat_curdate!
	echo.
goto :MAIN

:MAIN
	find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!">nul:
	if !errorlevel! neq 0 goto :ERR1

	echo   find /i "Delay will be from the earliest" "!bat_sunsettable!"
	for /f "usebackq tokens=1-2* delims=," %%a in (`find /i "Wall Timer ON" "!bat_sunsettable!"%>nul:`) do (
		set bat_scheduledstarttime=%%a
	)
	echo 	Task Scheduler Start Time (Wall timer ON)=!bat_scheduledstarttime!
	echo.

	echo   find /i "Latest wall timer hour" "!bat_sunsettable!"
	for /f "usebackq tokens=1-5* delims=," %%a in (`find /i "Wall Timer OFF" "!bat_sunsettable!"%>nul:`) do (
		set bat_walltimeroff=%%a
	)
	echo 	Task Scheduler Stop Time (Wall timer OFF)=!bat_walltimeroff!
	echo.

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dawn off offset" "!bat_sunsettable!"`) do (
		set bat_sa_off=%%d
		set bat_sunangleoff=           %%d
		set bat_sunangleoff=!bat_sunangleoff:~-7!
	)

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dusk on offset" "!bat_sunsettable!"`) do (
		set bat_sa_on=%%d
		set bat_sunangleon=            %%d
		set bat_sunangleon=!bat_sunangleon:~-7!
	)

	echo            	         	         	    	   	   	Dusk   	Dusk     	Dawn						
	echo            	         	         	    	   	   	(UTC at	(LDT at   	(UTC at						
	echo            	Dawn OFF	Dusk ON  	Dur-	    	     	!bat_sa_on! below	!bat_sa_on! below   	!bat_sa_off! below						
	echo   Date    	8o       	8o       	ation	Delay  	DST	horizon	horizon   	horizon   	date    	sunrise	sunset  	Day #
	echo   ====    	======== 	=======  	=====	=====  	===========	=======   	=======   	======= 	=======	======= 	=====
	for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
		echo   %%a    %%b        %%c        %%d   %%e    %%f       %%g %%h      %%i        %%j        %%k %%l      %%m
	)
	rem find /i "!bat_curm!/!bat_curd!/!bat_cury!" "sunsettable.txt"|find /i /v "!bat_sunsettable!"
	echo.
	echo   for /f "usebackq tokens=1-16 delims=, skip=1" %%a in (`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"`) do ...
	for /f "usebackq tokens=1-16 skip=2 delims=," %%a in (`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"`) do (
	echo.
		if "%%a" neq "----------" (
			echo    Date=               %%a  - Date of these calculations ^(!bat_weekday!^)
			call :CALCDAYNUMBER %%m
			echo    Day number=         !bat_res3!         - Day of the year 
			echo    Task Sched Start    !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time        !time:~0,8!    - Current local time
			echo.
			echo    Sunset Local=       %%l  - Local sunset time
			echo    Camera ON Local     %%h  - Local time of the first frames, Use this to set our wall timer.
			echo    Camera ON=          %%c    - Local time Task Scheduler should start capture
			echo    Camera ON UTC       %%g     - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle !bat_sunangleon!     - degrees below horizon
			echo.
			echo    Camera OFF UTC       %%i   - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %%b   - Local time capture should end in the morning
			echo    Sunrise Local=       %%k    - Local sunrise time ^(next morning^)
			echo    Camera OFF sun angle!bat_sunangleoff!     - degrees below horizon
			echo.
		for /f "tokens=1,2 delims=." %%x in ("%%d") do (

			set /a bat_h=%%x
			set /a bat_d=%%y
			call :STRIPZEROS %%x bat_h
			call :STRIPZEROS %%y bat_d
			set bat_d=!bat_d!00
			set bat_d=!bat_d:~0,2!
			
			set /a bat_durtotalseconds=!bat_h!*3600 + !bat_d!*36
		)

			echo    Duration=            %%d      - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Delay=               %%e       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
			echo    DST=                 %%f          - 1 if this date uses DST.  0 if not
			echo                                      Note: Dawn is calculated for the next morning
			set /a bat_estCapFiles=!bat_durtotalseconds!/8
			set /a bat_estSizeMB=!bat_estCapFiles!*1229/1000
			echo    Disk space required=!bat_estSizeMB! MB
			echo call "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalseconds!
rem			call "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalseconds!
			echo.
		)
	)
goto :DONE

:CALCDAYNUMBER
	rem Usage: call :CALCDAYNUMBER day
	rem   where day is the day number from the sunsettable.txt file.  In that file,
	rem   the day number in in the file for the first date (01/01/2011) has a value
	rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	rem   The only thing that should be an issue between different people using this
	rem   is the bat_offset number below (109600), which may need to be adjusted 
	rem   depending how how many days of offset from a daylight savings date
	rem   is used as the base date.  
	rem
	rem   The 109600 number is essentially 1096.00, which represents 3 years
	rem   before. This algorithm is based on knowning that the 1st day of the 
	rem   year 3 years before is a known day of the week.
	
	set /a bat_day=%1*100
	set /a bat_offset=109600
	set /a bat_year=36525
	
	set /a bat_divide=(((!bat_day!+!bat_offset!)*10000)/!bat_year!)
	set /a bat_int=((!bat_day!+!bat_offset!)/36525)
	set /a bat_mod=!bat_divide!-(!bat_int!*10000)
	set /a bat_res1=!bat_mod!*36525
	set /a bat_res2=!bat_res1!+100000
	set /a bat_res3=(!bat_res2!/1000000)+1
	set bat_res3=!bat_res3!   
	set bat_res3=!bat_res3:~0,3!
goto :EOF

:ERR1
	echo.
	echo ERROR - Date not found: "!bat_curm!/!bat_curd!/!bat_cury!"
	echo.
goto :DONE

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b


:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b

:HELP
	echo,
	echo Script presents a report on the dusk/dawn information based on
	echo the SunsetTable.txt.  The SunsetTable.txt file is generated using
	echo the following steps:
	echo   1) Use Microsoft Excel for the "twilight.xlsm" file
	echo   2) Edit the fields in yellow and the select all, copy.  
	echo   3) Then open the "SunsetTable.txt" file with Notepad
	echo   4) Delete all the existing text in the file
	echo   5) Then Paste.
	echo   6) Save and close Notepad and Excel.
	echo.
	echo The script displays the entry that contains the specified
	echo date in table form.  Then it provides an intepreted report
	echo in list form.  
exit /b

	
:DONE